import { Controller, EventListenerController } from '@a11d/lit';
export class PointerPressController extends Controller {
    constructor(host, options) {
        var _a;
        super(host);
        this.host = host;
        this.options = options;
        this._press = false;
        this.pointerDown = new EventListenerController(this.host, {
            type: 'pointerdown',
            target: (_a = this.options) === null || _a === void 0 ? void 0 : _a.target,
            listener: () => this.setPress(true)
        });
        this.pointerUp = new EventListenerController(this.host, {
            type: 'pointerup',
            target: document,
            listener: () => this.setPress(false)
        });
    }
    get press() { return this._press; }
    setPress(press) {
        var _a, _b;
        if (this._press !== press) {
            this._press = press;
            (_b = (_a = this.options) === null || _a === void 0 ? void 0 : _a.handlePressChange) === null || _b === void 0 ? void 0 : _b.call(_a, press);
            this.host.requestUpdate();
        }
    }
}
